//
// Created by robin on 1/23/18.
//

#ifndef QDNSAGG_QDNSRECORDDATAPTR_H
#define QDNSAGG_QDNSRECORDDATAPTR_H

#include <qplatformdefs.h>
#include <QByteArray>
#include <QDataStream>
#include <QHostAddress>
#include "QDnsRecordData.h"

namespace QDns
{
    namespace Base
    {
        class QDnsRecordDataPTR : public QDnsRecordData
        {
        public:
            QDnsRecordDataPTR();

            QDnsRecordDataPTR(const QByteArray &packetData, quint32 pos);

            QDnsRecordDataPTR(const QByteArray &packetData, QDataStream &dataStream);

            QByteArray serialize() const override;

            void serialize(QDataStream &dataStream) const override;

            virtual QDnsRecordData* clone() const override;

            const QString &getHostname() const;

            void setHostname(const QString &hostname);

            QString toString() const override;

        private:
            void parse(const QByteArray &packetData, QDataStream &dataStream);

            QString m_hostname;
        };
    }
}

#endif //QDNSAGG_QDNSRECORDDATAPTR_H
