//
// Created by robin on 2/7/18.
//

#ifndef QDNSAGG_QDNSTCPCLIENT_H
#define QDNSAGG_QDNSTCPCLIENT_H

#include <QtNetwork/QTcpSocket>
#include "QDnsClient.h"

namespace QDns
{
    namespace Client
    {
        class QDnsTcpClient : public QDnsClient
        {
            Q_OBJECT
        public:
            explicit QDnsTcpClient(const QHostAddress &host, quint16 port = 53, QObject* parent = nullptr);

        public slots:
            void connectToHost() override;
            void disconnectFromHost() override;

        protected:
            void doQuery(QDns::Base::QDnsPacket packet) override;

        private slots:
            void onSocketReadyRead();
            void onSocketStateChanged(QAbstractSocket::SocketState socketState);
            void onSocketError(QAbstractSocket::SocketError error);

        private:
            QTcpSocket* m_socket;

            QByteArray m_buffer;

            quint16 m_size;
        };
    }
}

#endif //QDNSAGG_QDNSTCPCLIENT_H
