//
// Created by robin on 1/31/18.
//

#include <QTcpSocket>
#include "dns-server/QDnsTcpServer.h"
#include "QDnsTcpServerClient.h"

namespace QDns
{
    namespace Server
    {
        QDnsTcpServer::QDnsTcpServer(QObject* parent)
            : QDnsServer(parent)
            , m_socket(new QTcpServer(this))
        {
            connect(m_socket, &QTcpServer::newConnection, this, &QDnsTcpServer::onNewConnection);
        }

        bool QDnsTcpServer::start(const QHostAddress &host, quint16 port)
        {
            return m_socket->listen(host, port);
        }

        void QDnsTcpServer::onNewConnection()
        {
            auto socket = m_socket->nextPendingConnection();
            if (socket == nullptr)
            {
                return;
            }
            auto client = new QDnsTcpServerClient(socket, this);
            connect(socket, &QTcpSocket::disconnected, [client, this]()
            {
                m_clients.removeOne(client);
                client->deleteLater();
            });
            connect(client, &QDnsTcpServerClient::onRequest, [this](QDnsServer::OnRequestParams params)
            {
                emit onRequest(params);
            });
            m_clients.append(client);
        }
    }
}