//
// Created by robin on 2/1/18.
//

#ifndef QDNSAGG_QTCPDNSSERVERCLIENT_H
#define QDNSAGG_QTCPDNSSERVERCLIENT_H

#include <QtCore/QObject>
#include <QtNetwork/QTcpSocket>
#include <dns-server/QDnsServer.h>

namespace QDns
{
    namespace Server
    {
        class QDnsTcpServerClient : public QObject
        {
            Q_OBJECT
        public:
            explicit QDnsTcpServerClient(QTcpSocket* socket, QObject* parent = nullptr);

        signals:
            void onRequest(QDnsServer::OnRequestParams params);

        public slots:
            void sendAnswer(const QDns::Server::QDnsServer::SendAnswerParams& answerParams);

        private slots:
            void onReadyRead();

        private:
            QTcpSocket* m_socket;

            QByteArray m_buffer;

            quint16 m_size;
        };
    }
}

#endif //QDNSAGG_QTCPDNSSERVERCLIENT_H
